// File Name: ServerImpl.java
// Date: Aug 23, 2004
// Date: Apr 28, 2003
// Edited by: Eiji Inoue


import java.rmi.*;
import java.rmi.server.*;


public class ServerImpl extends UnicastRemoteObject implements Server {
	Client client;
	static String serverName;
        static int[] r_cmd, r_dat, cmd_buf, rpl_buf;
	static int length;
	static cam p;
	static String s3 = "";


	static {
		try {
			serverName = java.net.InetAddress.getLocalHost().getHostName();
		}catch(Exception e){
			serverName = "localhost";
		} 
	}
	
	public ServerImpl() throws Exception {
		super();
	        r_cmd   = new int[4096*16];
	        r_dat   = new int[4096*16];
                cmd_buf = new int[4096*16];
                rpl_buf = new int[4096*16];
		p = new cam();

	} 
	
//	public void register (Client aclient) {
//		client = aclient;
//	}
	
	public String camac_cmd(int[] cmd, int[] dat, int length, int examN) throws RemoteException{

           System.out.println(" RMI: Server side: ");
           System.out.println("   JNI, Java side: Received CAMAC command: " + "array length = " + length);
//           System.out.println("   RMI: Received CAMAC command: " + "array length = " + length);
           for (int i = 0; i < length + 1; i++)
               System.out.println("      cmd[" + i + "] = 0x" + Integer.toHexString(cmd[i]) + ", dat[" + i + "] = 0x" + Integer.toHexString(dat[i]));

	ServerImpl.r_cmd = cmd;
	ServerImpl.r_dat = dat;
	ServerImpl.length = length;

//JNI
    try{
    System.out.println();
    System.out.println("   JNI, Java side: before Native Call");
    for (int i = 0; i < ServerImpl.length + 1; i++)
         System.out.println("      ServerImpl.r_cmd[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_cmd[i]) + ", ServerImpl.r_dat[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_dat[i]));


    int sum = ServerImpl.p.cmdArray(ServerImpl.r_cmd, ServerImpl.r_dat, ServerImpl.cmd_buf, ServerImpl.rpl_buf, ServerImpl.length, examN);

//    if ( examN != 0) {
       ServerImpl.length = ServerImpl.cmd_buf[1] / 2;
//    } else {
//       ServerImpl.length = length;
//    }
    System.out.println();
    System.out.println("   JNI, Java side: after Native Call" + " array length = " + ServerImpl.length);
    for (int i = 0; i < ServerImpl.length + 1; i++) {
         System.out.println("      ServerImpl.r_cmd[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_cmd[i]) + ", ServerImpl.r_dat[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_dat[i]));
//         System.out.println("      ServerImpl.r_cmd[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_cmd[i]) + ", ServerImpl.r_dat[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_dat[i]) + ", ServerImpl.cmd_buf[" + i + "] = 0x" + Integer.toHexString(ServerImpl.cmd_buf[i]) + ", ServerImpl.rpl_buf[" + i + "] = 0x" + Integer.toHexString(ServerImpl.rpl_buf[i]));
    }
    System.out.println();

//        client.camac_reply (ServerImpl.r_cmd, ServerImpl.r_dat, ServerImpl.cmd_buf, ServerImpl.rpl_buf, ServerImpl.length);

   } catch ( Exception e ) {
       System.err.println ("Failed to exec for camac");
   }

//JNI end
//   s3 = "ServerImpl.cmd_buf = " + ServerImpl.cmd_buf + "ServerImpl.rpl_buf = " + ServerImpl.rpl_buf + "\n";
   s3 = " reply_command = 0x" + Integer.toHexString(ServerImpl.r_cmd[0]) + ",   reply_data = 0x" + Integer.toHexString(ServerImpl.r_dat[0]) + "\n";
   return s3;
	}
	
	public static void main(String argv[]) throws Exception {
		//System.setSecurityManager(new RMISecurityManager());
		ServerImpl obj = new ServerImpl();
		Naming.bind("//"+serverName+"/Server", obj);
		System.out.println("bind done");
	}  
}
